#include <stdio.h>
#include "cmd.h"
#include "def.h"


/*
 *	ASK_ANSWER -------------------------------------------------------------
 *	Prints the question on the terminal, and then reads the answer.
 *	Returns the answered string, or the given default if a single
 *	"return" was answered.
 */
ACTION
ask_answer(question,dfault,answer)
char	*question, *dfault, *answer;
{
		BOOL	asked = FALSE;		/* has question been asked ? */
	extern	char	Ch;
	extern	BOOL	endofline();

	while (DELIMITER(Ch)) {
		if (! asked && Ch == '\n') {
			printf("%s%s",Bquestion,question);
			if (dfault != NULL && *dfault != '\0')
				printf("%s%s%s",Bdefault,dfault,Edefault);
			printf("%s",Equestion);
			fflush(stdout);
			asked = TRUE;
		}
		else
		if ((asked && endofline()) || Ch == ';') {	/*  default  */
			if (dfault == NULL || *dfault == '\0') {
				error("There is no default answer to this question.");
				asked = FALSE;
				continue;
			}
			else {
				strcpy(answer,dfault);
				return (CONT);
			}
		}
		Ch = in_char();
		if (Ch == '!') {
			cmd_shell();
			asked = FALSE;
			continue;
		}
	}
	if (in_item(answer) == NULL)
		return (STOP);
	return (CONT);
}
