#include	<stdio.h>
#include	"cmd.h"
#include	"def.h"

/*
 *      ASK_UN_RANGE -------------------------------------------------------------
 *      Asks the given question and returns the unsigned number the user answers.
 *	Uses "ask_answer" to do the actual writing and reading.
 *	Global commands are recognized and executed, after which the question
 *	is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
 */

	ACTION
ask_un_range(question, dfault, number, low, high, helpfile)
char	*question, *helpfile;
int	dfault, *number;
{
		ACTION	status;
		CMD *	global;
		char	df_string[11];
		char	answer[MAXLEN];
		int     value, new_dfault;
		char    new_question [112];
		char   *limit;
		int     ret;

	extern  int     Help_type;
	extern  char *  Help_file;
	extern  char *  Help_text;
	extern	ACTION	ask_answer();

	limit  = "'\0'        ";
	strcpy(new_question,question);
	strcat(new_question,"[");
	strcat(new_question,pr_any(low));
	strcat(new_question," - ");
	strcat(new_question,pr_any(high));
	strcat(new_question,"]");

	if((unsigned int)low >(unsigned int) high)
	{
	    pmess("Ill formulated range: %s",new_question);
	    return(CONT);
	}

	while (TRUE)
	{
	    if (dfault == NO_NUMBER)
		strcpy(df_string,"");
	    else
	    {
		switch(Outm_index)
		{
		default:
		    ill_outmode();
		case KEY_DECIMAL:
		    sprintf(df_string,"%d",dfault);     break;
		case KEY_OCTAL:
		    sprintf(df_string,"0%o",dfault);    break;
		case KEY_HEXA:
		    sprintf(df_string,"x%x",dfault);    break;
		}
	    }

	    if (ask_answer(new_question,df_string,answer) == STOP)
		return (STOP);

	    ret = cmd_match(answer, NULL, NULL, &global);
	    switch(ret)
	    {
	    case MATCH_AMB:
		break;
	    case MATCH_NOT:
		if (ask_any(number, answer) < 0)
		    break;

		if((unsigned int)(*number) < (unsigned int)low || 
		   (unsigned int)(*number) > (unsigned int)high)
		{
		    pmess(" * You were expected to stay in range");
		    break;
		}
		return (CONT);
	    case MATCH_GLO:
		Help_type = H_NUMBER;
		Help_file = helpfile;
		Help_text = "an integer number";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    } /* end switch (ret ... */
	} /* end of while */
}

