#include <stdio.h>
#include <signal.h>
#include "cmd.h"
#include "def.h"

/*
 *	CMD_FATAL -------------------------------------------------------------
 *	A fatal error has occurred.
 *	Obey the application's last will,
 *	print an error message,
 *	make a core dump in the Home directory,
 *	and stop execution.
 */
cmd_fatal(routine,message)
char *	routine;	/* name of the function that detected the error */
char *	message;	/* error message */
{
	extern	char	Home[];
	extern	int	last_will();	/* to be supplied by application */

	set_interrupt(INT_OFF);
	signal(SIGQUIT,SIG_IGN);
	last_will(routine,message);
	printf("%sSystem error detected by %s:%s%s%s",
		Berror,routine,Cerror,message,Cerror);
	fflush(stdout);
	chdir(Home);
	abort();	/* make core dump and die ... */
}
