#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	LEFTSUB ----------------------------------------------------------------
 *	Check if s1 is left justified substring of s2.
 *	
 *	Jan 8 1987: Robert G.K. Hart
 *	The 2 arguments are checked against referencing address #0.
 *	(No indirection over address #0)
 */
BOOL
leftsub(s1,s2)
register char *s1, *s2;
{
	if (s1 == NULL || s2 == NULL)
		return (FALSE);		/* no reference to address #0 */ 
	if (*s2 != '\0')
		while (*s1 == *s2)
			if (*++s1 == '\0')
				return (TRUE);
			else
				++s2;
	return (FALSE);
}
