/*
**      The structure Global_cmds should be by itself in a single file.
**      In order to permit the user to load its own copy of globals.
*/

#include	<stdio.h>
#include	"cmd.h"
#include	"def.h"

extern	ACTION	cmd_qmark();
extern	ACTION	cmd_exit();
extern	ACTION	cmd_help();
extern	ACTION	cmd_input();
extern	ACTION	cmd_quit();
extern	ACTION	cmd_restart();
extern	ACTION	cmd_outmode();


CMDLIST	Global_cmds =  {
	{ "GLOBALS",	NULL } ,
	{ "?",		cmd_qmark },
	{ "exit",	cmd_exit },
	{ "help",	cmd_help },
	{ "input",	cmd_input },
	{ "quit",	cmd_quit },
	{ "restart",	cmd_restart },
	{ "outmode",	cmd_outmode },
	{ NULL,		NULL }
};

