#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/mman.h>
#include	<fcntl.h>
#include	<errno.h>
#include	<signal.h>
#include	<sys/ioctl.h>
#include	"vmehb_ioctl.h"
int	pid;
int	count = 0;
int	len= 0;
int 	addr;
/* parametrization of testers */
#define	BUF_LEN		0x10000
#define	EVERY_UMPTH	0x8000
#define	NO_MORE_ERRORS	21
#define	REPORTS_ON	/**/
#define NO_INTERRUPTS_FROM_ME /**/
int i,fd,fd2;
void kill_me()
{
#ifdef	NO_INTERRUPTS_FROM_ME
	printf("\%d on %x finishing  :  len %4x  times %x\n"
			,pid,addr,len,count);
#endif
	sleep(2);
	close(fd);
	exit(1);
}
main(argc,argv)
int argc;
char	*argv[];
{
	extern int errno;
	struct vme_dev	Vme;
	unsigned int
		pattern;
	int	pat_mode;
	int	local_arg;
	int	loop_access;
	char	dev[80];
	char	buf[BUF_LEN];
	int	*ibuf = (int *)buf;
	short	*sbuf = (short *)buf;
	int	*mbuf;
	short	spat[16]= {0x0000,0x1111,0x2222,0x3333,
			   0x4444,0x5555,0x6666,0x7777,
			   0x8888,0x9999,0xaaaa,0xbbbb,
			   0xcccc,0xdddd,0xeeee,0xffff};
	int 	ipat[16]= {0x00000000,0x11111111,0x22222222,0x33333333,
	                   0x44444444,0x55555555,0x66666666,0x77777777,
	                   0x88888888,0x99999999,0xaaaaaaaa,0xbbbbbbbb,
	                   0xcccccccc,0xdddddddd,0xeeeeeeee,0xffffffff};
	int	cnt;
	int	errcnt = 0;
	int 	acc;
	int	cmd;
	int	err;
	int	devno;
	errno = 0;
	count = 0;
	pid = getpid();
#ifdef NO_INTERRUPTS_FROM_ME
	signal(SIGINT,kill_me);
#endif
change_dev:
	printf("dev:  ");
	scanf("%s",dev);
 	printf("Try to open %s pid %d (x%x)\n",dev,pid,pid);	
	fd = open(dev,O_RDWR); /**/
	if(errno) {perror("open ");goto change_dev;};
	errno = 0;
	ibuf[0] = 0x11110000;
	ibuf[1] = 0x33332222;
	ibuf[2] = 0x55554444;
	ibuf[3] = 0x77776666;
	ibuf[4] = 0x99998888;
	ibuf[5] = 0xbbbbaaaa;
	ibuf[6] = 0xddddcccc;
	ibuf[7] = 0xffffeeee;
	ibuf[8] = 0x11110000;
	ibuf[9] = 0x33332222;
	for(i = 0;i < 16;i++)
	err = lseek(fd,0,0); /**/
		if(errno) {printf("err %x\n: ",err);perror("lseek 0");};/**/
again:
	printf("access:\t 0 - read\n\t 1 - write\n\t 2 - map\n\t 3 - ioctl\n\t 4 - set data\n\t 9 - change dev\n\t-1 - exit: ");
	scanf("%x",&acc);
	if(acc < 0)
	{
		printf("Exiting\n");
		kill_me();
	}
	if(acc == 9)
	{
		close(fd);
		if(errno) perror("close ");
		goto change_dev;
	}
	if(acc < 3)
	{
		printf("Vme address on %s (0 = exit)  : ",dev);
		scanf("%x",&addr);
		printf("%s len 0-0x8000: ",acc == 0 ? "Read  ":
					   acc == 1 ? "Write ": "Mmap");
		scanf("%x",&len);
		if(addr == 0 || len == 0)
			goto close_me;
		err = lseek(fd,addr,0); /**/
			if(errno) {printf("err %x\n: ",err);perror("lseek ");exit(1);};/**/
		errno = 0;
		printf("loop(1) or single(0): ");
		scanf("%x",&loop_access);
		if(loop_access < 0 || loop_access > 1)
			loop_access = 0;
	}
	if(acc == 4)
		goto set_me_data;
	if(acc == 3)
		goto ioctl_me;
	if(acc == 2)
		goto map_me;
	if(acc == 1)
		goto write_me;
	if(acc == 0)
		goto read_me;
	goto again;
set_me_data:
	printf("pattern: 0 -  seq words\n\t 1 - seq longs\n\t 2 - bit patern\n");
	scanf("%d",&pat_mode);
	switch(pat_mode) {
	case	0:
		for(i = 0;i < (BUF_LEN >> 1);i++)
		{
			sbuf[i] = spat[i%16];
		}
		break;
	case	1:
		for(i = 0;i < (BUF_LEN >> 2);i++)
			ibuf[i] = ipat[i%16];
		break;
	case	2:
		printf("32 bits pattern for the data: ");
		scanf("%lx",&pattern);
		for(i = 0;i < 0x2000;i++)
			ibuf[i] = pattern;
		break;
	default:
		printf("Pattern not changed\n");
		break;
	}
	for(i = 0;i < 10;i++)
		printf("%x %x %x %x %x %x %x %x\n"
			,ibuf[0],ibuf[1],ibuf[2],ibuf[3]
			,ibuf[4],ibuf[5],ibuf[6],ibuf[7]
			);
	goto again;
ioctl_me:
	printf("ioctl:\t 0 - get space\n\t 1 - set space\n");
	printf("\t 2 - check\n\t 3 - slow control\n\t 4 - dma control\n");
	printf("\t 5 - VME AM  \n\t 6 - VME DMA MODE\n");
	printf("\t10 - crate off\n\t11 - crate on\n");
	printf("\t61 - clear VME mapping\n");
	printf("\t62 - zombies trace\n");
	printf("\t63 - print trace\n\t-1 - goto again:"); 
	scanf("%d",&cmd);
	if(cmd < 0)
		goto again;
	errno = 0;
	switch(cmd) {
	case	0:
		ioctl(fd,VME_GET_SPACE,&Vme);
		if(errno)
			perror("ioctl  get space:");
		if(errno)
			break;
	   	printf("%s %s: AM %x dmamod %s - %x bytes [0,%x]\n"
			,(Vme.fu == 1 ? "VME":
                          Vme.fu == 3 ? "Dual Port":
			  Vme.fu == 2 ? "VME RAM" : "unknown ")
			,Vme.name
			,Vme.am
			, (Vme.dmamod == RC2_DMA_BLK_SEL) ? "block" :
		  	  (Vme.dmamod == RC2_DMA_PAUSE  ) ? "pause" : "non block" 
			,Vme.mod
			,Vme.maxad
			);
		break;
	case	1:
		ioctl(fd,VME_SET_SPACE,&Vme);
		if(errno)
			perror("ioctl  set space");
		break;
	case	2:
		printf("Check:\t 0 - dma\n\t50 - check ");
		scanf("%d",&local_arg);
		errno = 0;
		ioctl(fd,VME_CHECK_ACCESS,&local_arg);
		if(errno)
			perror("ioctl  slow control");
		break;
	case	3:
		printf("Slow c:\t 0 - dma\n\t 1 - slow control ");
		scanf("%d",&local_arg);
		errno = 0;
		ioctl(fd,VME_SLOW_CONTROL,&local_arg);
		if(errno)
			perror("ioctl  slow control");
		break;
	case	4:
		printf("Dma:\t 0 - poll\n\t 1 - irq ");
		scanf("%d",&local_arg);
		errno = 0;
		ioctl(fd,VME_DMA_CONTROL,&local_arg);
		if(errno)
			perror("ioctl  dma control");
		break;
	case	5:
		printf("VME address modifier: ");
		scanf("%x",&local_arg);
		errno = 0;
		ioctl(fd,VME_SET_AM,&local_arg);
		if(errno)
			perror("ioctl  set am");
		break;
	case	6:
		printf("DMA transfer mode {0,20(b) or 80(p)}: ");
		scanf("%x",&local_arg);
		errno = 0;
		ioctl(fd,VME_SET_DMAMOD,&local_arg);
		if(errno)
			perror("ioctl  set am");
		break;
	case	10:
		ioctl(fd,VME_CRATE_OFF,&Vme);
		if(errno)
			perror("ioctl  crate off");
		break;
	case	11:
		ioctl(fd,VME_CRATE_ON,&Vme);
		if(errno)
			perror("ioctl  crate  on");
		break;
	case	61:
		ioctl(fd,VME_CLEAR_MAPS,&Vme);
		if(errno)
			perror("ioctl clear maps");
		sleep(1);
		break;
	case	62:
		ioctl(fd,VME_TRACE_ZOMBIES,&Vme);
		if(errno)
			perror("ioctl trace zombies");
		sleep(1);
		break;
	case	63:
		ioctl(fd,VME_TRACE_INFO,&Vme);
		if(errno)
			perror("ioctl print trace");
		sleep(1);
		break;
	default:
		printf("Function %d NIY\n",cmd);
		break;
	} /* end switch(cmd); */
	errno = 0;
	goto ioctl_me; /**/
/* ------------------------------------- */
map_me:
	errno	= 0;
	lseek(fd,0,0);
	err = (int) mmap(0,len,3,MAP_SHARED,fd,addr);
	if(errno)
		{perror("mmap");goto again;}
	/*
	mbuf = (int *)err;
	printf("mmapped into: %x\n",(int)mbuf);
	printf("try to read: %x\n",*mbuf);
	printf("try to write: 0x888666\n");
	/**/
	printf("	Mapping done\n");
	if(!loop_access)
		goto again;
write_map:
	count++;
	if(count > 0x7ffffff0)
		count = 0;
	*mbuf = count;
	local_arg = *mbuf;
	if(local_arg != count)
	{
		printf("%4d (m) : VME %8x written %x read %x\n"
			,pid ,addr ,count ,local_arg );
		sleep(2);
	}
		
#ifdef REPORTS_ON
	if((count % ((EVERY_UMPTH) << 4)) == 0)
	{
		printf("%4d (m) : VME %8x len x%4x times %x\n"
			,pid ,addr ,len ,count );
	}
#endif
	if(loop_access)
		goto write_map;
	if(err > 0)
		munmap((void *)err,len);
	if(errno)
		{perror("munmap");goto again;}
	goto again; /**/
/* ------------------------------------- */
write_me:
	count++;
	if(count > 0x7ffffff0)
		count = 0;
#ifdef REPORTS_ON
	if((count % EVERY_UMPTH) == 0)
	{
		printf("%4d (w) : VME %8x len x%4x times %x\n"
			,pid ,addr ,len ,count );
	}
#endif
	cnt = write(fd,buf,len);
		if(errno) {perror("write ");exit(1);};
	if(cnt != len)
	{
		printf("Write err %d: %d  (x%x) from %d (x%x) count %x  addr %x\n"
			,pid,cnt,cnt,len,len,count,addr);
		errcnt++;
		if(errcnt > NO_MORE_ERRORS)
		{
			printf("Exiting on persistent error\n");
			kill_me();
		}
	}
	else
		errcnt = 0;
	if(loop_access)
		goto write_me;/**/
	printf("Write %d: %d  (x%x) from %d (x%x) count %x  addr %x\n"
			,pid,cnt,cnt,len,len,count,addr);
   	goto again; /**/
read_me:
	count++;
	if(count > 0x7ffffff0)
		count = 0;
#ifdef REPORTS_ON
	if((count % EVERY_UMPTH) == 0)
	{
		printf("%4d (r) : VME %8x len x%4x times %x\n"
			,pid ,addr ,len ,count );
	}
#endif
	cnt = read(fd,buf,len);
		if(errno) {perror("read ");exit(1);};
	if(cnt != len)
	{
		printf("Read  err %d: %d  (x%x) from %d (x%x) count %x \n"
			,pid,cnt,cnt,len,len,count);
		errcnt++;
		if(errcnt > NO_MORE_ERRORS)
		{
			printf("Exiting on persistent error\n");
			kill_me();
		}
	}
	else
		errcnt = 0;
	if(loop_access)
		goto read_me;/**/
	printf("Read  %d: %d  (x%x) from %d (x%x) count %x  addr %x\n"
			,pid,cnt,cnt,len,len,count,addr);
	goto again; /**/
close_me:
	printf("	Closing\n");
	close(fd);
	if(errno) perror("close ");
}
