#include	<stdio.h>
#include	<signal.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/ipc.h>
#include	<sys/shm.h>

#define		TESTDEV
/* */
#define		DEV1		"/dev/vme24d32"
#define		OFF1		0x800000
#define		SIZ1		0x104
#define		DEV2		"/dev/vme24d32"
#define		OFF2		0x800200
#define		SIZ2		0x104
#define		DEV3		"/dev/vme24d16"
#define		OFF3		0x524000
#define		SIZ3		0x104
/**/
/* UNDEFINE 
#define		DEV1		"aap"
#define		OFF1		0
#define		SIZ1		1024
#define		DEV2		"noot"
#define		OFF2		0
#define		SIZ2		1024
#define		DEV3		"noot"
#define		OFF3		0
#define		SIZ3		1024
/**/

int	Stop = 0;

void Control_C()	{

	signal( SIGINT , Control_C );
	signal( SIGHUP , Control_C );
	signal( SIGKILL , Control_C );
	signal( SIGQUIT , Control_C );

	Stop++;

}

void hunter( fm )
int	fm;	{

	int		fd, pid, status, n, data[SIZ3];
	int		*ptr;
	extern int	errno;

	ptr = (int *)shmat( fm , (char *)0 , 0 );
	if( ptr == (int *)-1 )	{
		printf( "Hunter-child: error while mapping shared memory (error %d)\n" , errno );
		exit( -1 );
	}
	ptr[4] = 0;
	ptr[5] = 0;

	do	{
		if( (pid = fork()) == 0 )	{
			ptr = (int *)shmat( fm , (char *)0 , 0 );
			if( ptr == (int *)-1 )	{
				printf( "Hunter-child: error while mapping shared memory (error %d)\n" , errno );
				exit( -1 );
			}
			signal( SIGINT , SIG_DFL );
			fd = open( DEV3 , O_RDWR );
			if( fd < 0 )	{
				printf(  "Error opening file %s\n" , DEV3 );
				exit( -1 );
			}
			lseek( fd , OFF3 , SEEK_SET );
			do	{
#ifdef TESTDEV
				lseek( fd , OFF3 , SEEK_SET );
#endif
				n = read( fd , data , SIZ3 );
				ptr[5]++;
			}	while( n  == SIZ3 );
			printf(  "Error reading victim (%d %d)\n" , n , errno );
			exit( -1 );
		}
		else	{
			usleep( 500000 );
			kill( pid , SIGINT );
			waitpid( pid , &status , 0 );
			ptr[4]++;
		}
	}	while( 1 );

}

main()	{

	int		i, fm, pid[3], fd[3];
	int		*ptr;
	char		*cont1, *cont2;
	struct shmid_ds	buffer;
	extern int	errno;

/*	Create shared memory segment */

	fm  = shmget( IPC_PRIVATE , 0x100 , IPC_CREAT | 0600 );
	if( fm < 0 )	{
		printf( "Shared memory could not be created (error %d)\n" , errno );
		exit( -1 );
	}

	i    = 0;

	if( (pid[0] = fork()) == 0 )	{

/*	Child 1: map memory to user */

		ptr = (int *)shmat( fm , (char *)0 , 0 );
		if( ptr == (int *)-1 )	{
			printf( "Child: error while mapping shared memory (error %d)\n" , errno );
			exit( -1 );
		}

		ptr[0] = 0;
		ptr[1] = 0;

		fd[0]  = open( DEV1 , O_RDWR );
		lseek( fd[0] , OFF1 , SEEK_SET );
		cont1 = (char *)malloc( SIZ1 );
		for( i=0; i<SIZ1; i++ )
			cont1[i] = i%256;
		write( fd[0] , cont1 , SIZ1 );

		while( 1 )	{
#ifdef TESTDEV
			lseek( fd[0] , OFF1 , SEEK_SET );
#endif
			if( read( fd[0] , cont1 , SIZ1 ) == SIZ1 )
				ptr[0]++;
			else
				ptr[1]++;

		}
	}
	else if( (pid[1] = fork()) == 0 )	{

/*	Child 2: map memory to user */

		ptr = (int *)shmat( fm , (char *)0 , 0 );
		if( ptr == (int *)-1 )	{
			printf( "Child: error while mapping shared memory (error %d)\n" , errno );
			exit( -1 );
		}

		ptr[2] = 0;
		ptr[3] = 0;

		fd[1]  = open( DEV2 , O_RDWR );
		lseek( fd[1] , OFF2 , SEEK_SET );
		cont2 = (char *)malloc( SIZ2 );
		for( i=0; i<SIZ2; i++ )
			cont2[i] = i%256;
		write( fd[1] , cont2 , SIZ2 );

		while( 1 )	{
#ifdef TESTDEV
			lseek( fd[1] , OFF2 , SEEK_SET );
#endif
			if( read( fd[1] , cont2 , SIZ2 ) == SIZ2 )
				ptr[2]++;
			else
				ptr[3]++;

		}
	}
	else if( (pid[2] = fork()) == 0 )	{

/*	Child 3, the one that hunts and shoots 	*/

		hunter( fm );

	}
	else	{

/*	Parent: map memory to user */

		ptr = (int *)shmat( fm , (char *)0 , 0 );
		if( ptr == (int *)-1 )	{
			printf( "Parent: error while mapping shared memory (error %d)\n" , errno );
			exit( -1 );
		}

	}

	signal( SIGINT , Control_C );
	signal( SIGHUP , Control_C );
	signal( SIGKILL , Control_C );
	signal( SIGQUIT , Control_C );

	for( i=0; i<100000; i++ )	{
		printf( "%5d %5d %5d %5d %5d %5d\n" , ptr[0] , ptr[1] , ptr[2] , ptr[3] , ptr[4] , ptr[5] );
		if( Stop )
			break;
		sleep( 1 );
	}

	kill( pid[0] , SIGINT );
	kill( pid[1] , SIGINT );

/*	Remove shared memory */

	shmctl( fm , IPC_RMID , &buffer );

}
