#ifndef	CMDEF_H
#	define	CMDEF_H
#	ifndef	AM_9519_H
#		include	"am_9519.h"
#	endif	AM_9519_H

/*
@@@  cmdef.h - to use only in CAMAC driver
@@@  contains internal file of CAMAC driver on CBD 8218 (CES)
@@@  hardware: sun4c/pti sun4e (sun4m)
*/

#define BRANCH                  0
#define CM_GROUP_VECTOR         0xca                    /* level 3      */
#define SLOT_SIZE               0x800                   /* slot size    */
#define MAX_CR_CTRL             3
#define TOP_SLOT                (31 + (MAX_CR_CTRL << 5))
#define PAGE_NO(slot)           ((slot) >> 2)           /* 4 slots page */
#define	S_NCM			(TOP_SLOT + 1)
#define	CM_PAGES		((S_NCM >> 2) + ((S_NCM & 0x3) ? 1 : 0))
#define SIGCAM                  SIGUSR1

/************ hardware dependency ***************************************/
#ifdef linux
/*	here we use soft vme addressing via mapping of vmehb		*/
#define	VME_PAGESIZE	0x1000
#	define  CAM_REGS     
#	define  CM_BASE         
#	define	PAGES_PER_4_SLOTS ((SLOT_SIZE << 2) / VME_PAGESIZE)
#endif
/************************************************************************/

#endif	CMDEF_H
