/*
** CAM_MAKE - MKCAMNOD,RMCAMNOD - user controlled symlinks
*/

#include        <sys/types.h>
#include        <sys/ioctl.h>
#include        <stdio.h>
#include        "camioctl.h"
#include        "camac.h"


mkcamnod(unsigned int c, unsigned int n,char * name)
{
	register	int	cminor		= (c << 5) | n;
			char	devnam[40];
			char	lcom[144];
	extern		char	Cam_stdname[];
	extern		int	Cam_stdpos;
	strncpy(devnam,Cam_stdname,strlen(Cam_stdname));
	sprintf(&devnam[Cam_stdpos],"%d",cminor);
	strcpy (lcom,"ln -s ");
	strcat (lcom,devnam);
	strcat (lcom," ");
	strcat (lcom,name);
	shell_call(lcom);
}

rmcamnod(char * name)
{
	char    lcom[80];

	if(!strncmp(name,"/dev",4))
	{
	    if(Cam_verbose == CAM_VERBOSE)
		fprintf(stderr,"rmcamnod: cannot remove %s\n",name);
	    return;
	}
	strcpy(lcom,"rm ");
	strcat(lcom," ");
	strcat(lcom,name);
	shell_call(lcom);
}

shell_call(char * arg)
{
		int	status, pid, result;
		char	*shell;
	register int (*	istat)();
	extern	char	*getenv();

	if(arg == (char *)0)
		return;
	if(Cam_verbose)
		fprintf(stderr,"called: %s :  \n",arg);
	if ((pid = fork()) == 0) {
	if ((shell = getenv("SHELL")) == (char *)0)
		shell = "/bin/sh";
	execl(shell,"sh","-c",arg,0);
	_exit(127);
	}
	while ((result = wait(&status)) != pid
		&& result != -1)	;
	if(Cam_verbose)
		fprintf(stderr,"...ready\n");
	return;
}
