#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	SET_INPUT --------------------------------------------------------------
 *	Select input stream for reading next command.
 *	Stream will be read until EOF.
 */
set_input(filename)
char *	filename;
{
	extern	INFILE	In[];
	extern	int	Inlevel;
	extern	char	Ch;
		char	pathname[MAXPATH];
	extern	char	Home[];
		int (*	save_interrupt)();

	if (Inlevel >= MAXINLEV) {
		error("Input streams can not be nested deeper than %d.",MAXINLEV);
		return;
	}
	if (*filename != '/')
	{	strcpy(pathname,Home);
		strcat(pathname,"/");
		strcat(pathname,filename);
	}
	else
		strcpy(pathname,filename);
	save_interrupt = set_interrupt(INT_OFF);
	back_char(Ch);
	++Inlevel;
	if ((STREAM = fopen(pathname,"r")) == NULL) {
		--Inlevel;
		Ch = in_char();
		error("Failed to open input stream %s.",filename);
	}
	else {
		Ch = '\n';	/* to force initial prompt */
		strcpy(FILENAME,filename);
		EOL = TRUE;
		BACK = LINE;
	}
	set_interrupt(save_interrupt);
	return;
}
